module DTD_autorizados where

import Xml2Haskell


{-Type decls-}

newtype Autorizados = Autorizados [Email] 		deriving (Eq,Show)
newtype Email = Email String 		deriving (Eq,Show)


{-Instance decls-}

instance XmlContent Autorizados where
    fromElem (CElem (Elem "autorizados" [] c0):rest) =
	(\(a,ca)->
	   (Just (Autorizados a), rest))
	(many fromElem c0)
    fromElem rest = (Nothing, rest)
    toElem (Autorizados a) =
	[CElem (Elem "autorizados" [] (concatMap toElem a))]
instance XmlContent Email where
    fromElem (CElem (Elem "email" [] c0):rest) =
	(\(a,ca)->
	   (Just (Email a), rest))
	(definite fromText "text" "email" c0)
    fromElem rest = (Nothing, rest)
    toElem (Email a) =
	[CElem (Elem "email" [] (toText a))]


{-Done-}
