module Verificacoes where

import DTD_Reservas
					
verificaChoqueHorario :: [Reserva] -> Recurso -> Quando -> Bool
verificaChoqueHorario [] _ _ = False
verificaChoqueHorario ((Reserva rec horarios _ _ _ _):rs) recurso h 			
		| rec /= recurso = verificaChoqueHorario rs recurso h
		| rec == recurso && (not (ha_choque horarios h)) = verificaChoqueHorario rs recurso h
		| otherwise = True
		

intervalo_valido :: Quando -> Bool
intervalo_valido (Quando _ _ _ (Hora_inicio hi) (Hora_fim hf)) = hf > hi

ha_choque :: [Quando] -> Quando -> Bool
ha_choque [] _ = False
ha_choque ((Quando (Dia d1) (Mes m1) (Ano a1) (Hora_inicio hi1) (Hora_fim hf1)):hs)
	   (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
	   	| a1 /= a2 || m1 /= m2 || d1 /= d2 = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
		| (hi2 >= hi1 && hi2 < hf1) || (hf2 <= hf1 && hf2 > hi1) = True 
		| otherwise = ha_choque hs (Quando (Dia d2) (Mes m2) (Ano a2) (Hora_inicio hi2) (Hora_fim hf2))
		
-- funo que depois ser modificada
podeReservar :: Login -> Bool
podeReservar _ = True		




{--adicionarReservas :: [Reserva] -> Reserva -> [Reserva]
adicionarReservas feitas reservas 
			| reserva == Nothing = feitas
			| otherwise = feitas ++ [auxiliar reserva]
				 where reserva = podeFazerReservas feitas reservas
				       auxiliar :: Maybe Reserva -> Reserva
				       auxiliar (Just res) = res

podeFazerReservas :: [Reserva] -> Reserva -> Maybe Reserva
podeFazerReservas feitas (Reserva rec horarios resp login set mot) 
		| podeReservar login = (Just (Reserva rec horarios resp login set mot))
		| otherwise = Nothing--}



